<?php

#
# XiVO Web-Interface
# Copyright (C) 2006-2014  Avencall
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

xivo_service_asterisk::required(array('abstract','datastorage','abstract','sql.inc'),true);

class xivo_service_asterisk_agentfeatures_sql extends xivo_service_asterisk_abstract_sql
{
	var $_unique = array('number');
	var $_disable = false;

	function search($value,$disable=null,$order=null,$limit=null)
	{
		$this->_cnt = 0;

		$this->_dso->new_select($this->_table);
		$this->_dso->wherecontain('firstname',$value);
		$this->_dso->orwherecontain('lastname',$value);
		$this->_dso->orwherecontain('number',$value);

		if(($concat = $this->_dso->concat(array((object) 'firstname',
							' ',
							(object) 'lastname'))) !== false)
			$this->_dso->orwherecontain((object) $concat,$value,true);

		if($this->_dso->aggregate_where() === false)
			return(false);

		$arr = array();

		if($disable !== null && isset($this->_disable) === true)
			$this->_dso->andwhere(array($this->_disable => intval((bool) $disable)));

		$this->_add_entity_filter();

		$this->_dso->new_order($order);
		$this->_dso->limit($limit);

		$r = $this->_dso->select_all();

		$this->_dso->reset_order();
		$this->_dso->reset_limit();

		if(($this->_cnt = $this->_dso->select_count()) === false
		|| isset($r[0]) === false)
			$r = false;

		return($r);
	}

	function get_by_number($num)
	{
		$this->_dso->new_select($this->_table,'*');

		$this->_dso->where(array('number' => (string) $num));

		$this->_add_entity_filter();

		$r = $this->_dso->select_single();

		if(empty($r) === true)
			$r = false;

		return($r);
	}

	function get_all_assoc()
	{
		$this->_dso->new_select($this->_table,'*');

		$this->_add_entity_filter();

		$r = $this->_dso->select_all('',true,false,'id');

		if(empty($r) === true)
			$r = false;

		return($r);
	}
}

?>
