<?php

#
# XiVO Web-Interface
# Copyright (C) 2006-2014  Avencall
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

xivo_service_asterisk::required(array('abstract','abstract.inc'),true);

class xivo_service_asterisk_context extends xivo_service_asterisk_abstract
{
	var $_dso			= null;
	var $_name			= 'context';
	var $_filter		= false;
	var $_origin		= false;
	var $_origin_list	= false;
	var $_identity		= false;

	public function __construct(&$sre,&$dso)
	{
		if(is_object($sre) === false)
			trigger_error('Invalid service in '.__CLASS__,E_USER_ERROR);

		if(is_object($dso) === false)
			trigger_error('Invalid datastorage in '.__CLASS__,E_USER_ERROR);

		$this->_sre = &$sre;
		$this->_dso = &$dso;

		$this->_load_config();
		$this->_identity = &$this->_sre->get_identity($this->_name);
	}

	function _prepare($data)
	{
		$this->_identity->_prepare_identity($data);

		$data['commented'] = (bool) $data['commented'];

		return($data);
	}

	function add($arr,$id=0)
	{
		if(is_array($arr) === false)
			return(false);
		else if(isset($arr['name']) === true)
			$arr['name'] = strtolower($arr['name']);

		return(parent::add($arr,$id));
	}

	function edit($id,$arr)
	{
		if(is_array($arr) === false)
			return(false);
		else if(isset($arr['name']) === true)
			$arr['name'] = strtolower($arr['name']);

		return(parent::edit($id,$arr));
	}

	function get_all($disable=null,$order=null,$limit=null,$assoc=false,$type=null)
	{
		if(isset($this->_origin_list) === true)
			$this->_origin_list = false;

		$arr = array();
		if (is_null($type) === false)
			$arr['contexttype'] = $type;

		if (empty($arr))
			$list = $this->_dso->get_all($disable,$order,$limit);
		else
			$list = $this->_dso->get_all_where($arr,$disable,$order,$limit);

		if(isset($list[0]) === false)
			return(false);
		else if(isset($this->_origin_list) === true)
			$this->_origin_list = $list;

		return($this->_mk_list_assoc_prepare($list,$assoc,true));
	}

	function search($value,$disable=null,$order=null,$limit=null,$type=null)
	{
		if(($list = $this->_dso->search($value,$disable,$order,$limit)) === false)
			return(false);

		$nb = count($list);

		$r = array();

		for($i = 0;$i < $nb;$i++)
			$r[] = $this->_prepare($list[$i]);

		if(isset($r[0]) === false)
			$r = false;

		return($r);
	}

	function get_all_except($name=null,$order=null,$limit=null,$assoc=false,$type=null)
	{
		if(dwho_has_len($name) === false)
			return($this->get_all(null,$order,$limit,$assoc));

		$name = strtolower($name);

		if(isset($this->_origin_list) === true)
			$this->_origin_list = false;

		if(($list = $this->_dso->get_all_except($name,$order,$limit)) === false
		|| isset($list[0]) === false)
			return(false);
		else if(isset($this->_origin_list) === true)
			$this->_origin_list = $list;

		return($this->_mk_list_assoc_prepare($list,$assoc,true));
	}

	function get_contexts_name_by_entity_name($entity_name,$disable=null,$order=null,$limit=null,$assoc=false,$type=null)
	{
		if(isset($this->_origin_list) === true)
			$this->_origin_list = false;

		$arr = array();
		$arr['entity'] = $entity_name;

		if (is_null($type) === false)
			$arr['contexttype'] = $type;

		$list = $this->_dso->get_all_where($arr,$disable,$order,$limit);

		if(isset($list[0]) === false)
			return(false);
		else if(isset($this->_origin_list) === true)
			$this->_origin_list = $list;

		return($this->_mk_list_assoc_prepare($list,$assoc,true));
	}
}

?>
