<?php

#
# XiVO Web-Interface
# Copyright (C) 2006-2014  Avencall
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

$url = &$this->get_module('url');
$form = &$this->get_module('form');
$dhtml = &$this->get_module('dhtml');

$pager = $this->get_var('pager');
$act = $this->get_var('act');
$dir = $this->get_var('dir');

$param = array();
$param['dir'] = $dir;

if(($search = (string) $this->get_var('search')) !== ''):
	$param['search'] = $search;
endif;

$page = $url->pager($pager['pages'],
		    $pager['page'],
		    $pager['prev'],
		    $pager['next'],
		    'service/ipbx/pbx_services/sounds',
		    array('act' => $act,$param));

?>
<div class="b-list">
<?php
	if($page !== ''):
		echo '<div class="b-page">',$page,'</div>';
	endif;
?>
<form action="#" name="fm-files-list" method="post" accept-charset="utf-8">
<?php
	echo	$form->hidden(array('name'	=> DWHO_SESS_NAME,
				    'value'	=> DWHO_SESS_ID)),

		$form->hidden(array('name'	=> 'act',
				    'value'	=> $act)),

		$form->hidden(array('name'	=> 'dir',
				    'value'	=> $dir)),

		$form->hidden(array('name'	=> 'page',
				    'value'	=> $pager['page'])),

		$form->hidden(array('name'	=> 'search',
				    'value'	=> ''));
?>
<table class="table table-condensed table-striped table-hover table-bordered" id="table-main-listing">
	<tr class="sb-top">
		<th class="th-left xspan"><span class="span-left">&nbsp;</span></th>
		<th class="th-center"><?=$url->href_html($this->bbf('col_file'),
						'service/ipbx/pbx_services/sounds',
						  array('act'	=> 'list',
								'dir'	=> $dir,
								'sort_key'	=> 'name',
								'sort_order'	=> $this->get_var('sort_order')));?></th>
		<th class="th-center"><?=$url->href_html($this->bbf('col_size'),
						'service/ipbx/pbx_services/sounds',
						  array('act'	=> 'list',
								'dir'	=> $dir,
								'sort_key'	=> 'size',
								'sort_order'	=> $this->get_var('sort_order')));?></th>
		<th class="th-center"><?=$url->href_html($this->bbf('col_date'),
						'service/ipbx/pbx_services/sounds',
						  array('act'	=> 'list',
								'dir'	=> $dir,
								'sort_key'	=> 'mtime',
								'sort_order'	=> $this->get_var('sort_order')));?></th>
		<th class="th-center col-action"><?=$this->bbf('col_action');?></th>
		<th class="th-right xspan"><span class="span-right">&nbsp;</span></th>
	</tr>
<?php
	if(($list = $this->get_var('list')) === false || ($nb = count($list)) === 0):
?>
	<tr class="sb-content">
		<td colspan="5" class="td-single"><?=$this->bbf('no_file');?></td>
	</tr>
<?php
	else:
		for($i = $pager['beg'],$j = 0;$i < $pager['end'] && $i < $pager['total'];$i++,$j++):

			$ref = &$list[$i];
			$size = dwho_size_iec($ref['size']);
?>
	<tr onmouseover="this.tmp = this.className; this.className = 'sb-content l-infos-over';"
	    onmouseout="this.className = this.tmp;"
	    class="sb-content l-infos-<?=(($j % 2) + 1)?>on2">
		<td class="td-left">
			<?=$form->checkbox(array('name'		=> 'files[]',
						 'value'	=> $ref['name'],
						 'label'	=> false,
						 'id'		=> 'it-files-'.$i,
						 'checked'	=> false,
						 'paragraph'	=> false));?>
		</td>
		<td class="txt-left curpointer"
		    onclick="location.href = dwho.dom.node.firstchild(this);">
			<?=$url->href_html($ref['name'],
					   'service/ipbx/pbx_services/sounds',
					   array('act'	=> 'download',
						 'dir'	=> $dir,
						 'id'	=> $ref['name'],
						 'page'	=> $pager['page']));?>
		</td>
		<td><?=$this->bbf('size_iec_'.$size[1],$size[0]);?></td>
		<td><?=dwho_i18n::strftime_l($this->bbf('date_format_yymmddhhii'),
					     null,
					     $ref['mtime']);?></td>
		<td class="td-right" colspan="2">
<?php
			echo	$url->href_html($url->img_html('img/site/button/edit.png',
							       $this->bbf('opt_modify'),
							       'border="0"'),
						'service/ipbx/pbx_services/sounds',
						array('act'	=> 'edit',
						      'dir'	=> $dir,
						      'id'	=> $ref['name']),
						null,
						$this->bbf('opt_modify')),"\n",
				$url->href_html($url->img_html('img/site/button/delete.png',
							       $this->bbf('opt_delete'),
							       'border="0"'),
						'service/ipbx/pbx_services/sounds',
						array('act'	=> 'delete',
						      'id'	=> $ref['name'],
						      'page'	=> $pager['page'],
						      $param),
						'onclick="return(confirm(\''.$dhtml->escape($this->bbf('opt_delete_confirm')).'\'));"',
						$this->bbf('opt_delete'));
?>
		</td>
	</tr>
<?php
		endfor;
	endif;
?>
</table>
</form>
<?php
	if($page !== ''):
		echo '<div class="b-page">',$page,'</div>';
	endif;
?>
</div>
